#include "Orion20m.h"
#include "cvel.h"

void ORION::hudprint(oapi::Sketchpad *skp, int x, int y, char buf[1024]) {
	if(true) {
#define OFS 1
		DWORD oldcolor=skp->SetTextColor (cfg->hudshadowcolor);
		skp->Text(x-OFS,y-OFS,buf,(int)strlen(buf));// FIXME: shitty
		skp->Text(x-OFS,y+OFS,buf,(int)strlen(buf));
		skp->Text(x+OFS,y-OFS,buf,(int)strlen(buf));
		skp->Text(x+OFS,y+OFS,buf,(int)strlen(buf));
		skp->SetTextColor (oldcolor);
		skp->Text(x,y,buf,(int)strlen(buf));
	} else {
		skp->Text(x,y,buf,(int)strlen(buf));
	}
}


#define hudline(s, ...) {char buf[1024];\
	sprintf_s(buf, 1024, s, __VA_ARGS__);\
		hudprint(skp,side_offset + 10, _from_top, buf);\
		_from_top += 2*_interval;\
}

#define thgrouphud(g,str){int thcount=GetGroupThrusterCount(g);\
	for (int i = 0; i < thcount; i++) {\
		th = GetGroupThruster(g, i);\
		GetThrusterRef(th, thref);\
		GetThrusterDir(th, thdir);\
		GetThrusterMoment(th,thmomentlin,thmomenttor);\
		thlevel=GetThrusterLevel(th);\
		thmax=GetThrusterMax(th);\
		thisp=GetThrusterIsp(th);\
		hudline("%s[%d]: %.1f%% %.2f, torque: (%+.2f,%+.2f,%+.2f)",str,i,thlevel*100,thmax,thmomenttor);\
	}\
}

/*
		if (rcs_shift_mode>=0) {\
			if (rcs_shift_mode==1) SetThrusterRef(th,_V(\
				thref.x+(rcs_shift_vec.x*-1)+vehsscg.x, \
				thref.y+(rcs_shift_vec.y*-1)+vehsscg.y, \
				thref.z+(rcs_shift_vec.z*-1)+vehsscg.z\
				));\
		}\
	}\
}
*/

void ORION::drawbox(oapi::Sketchpad *skp, int x, int y, int height, int width, double ratio) {
		char buf[128];
		oapi::Pen *rectfill;
		oapi::Pen *oldpen;
		oapi::Brush *rectfillbrush;
		oapi::Brush *oldbrush;

		rectfill=oapiCreatePen(1,1,cfg->hudfillcolor);//0x555500
		rectfillbrush=oapiCreateBrush(cfg->hudfillcolor);

		oldpen=skp->SetPen(rectfill);
		oldbrush=skp->SetBrush(rectfillbrush);
		int boxx2=x+width;
		int boxy2=y+height;

		skp->Rectangle(x,y,x+(int)(width*ratio),boxy2);
		oapiReleasePen(rectfill);
		oapiReleaseBrush(rectfillbrush);
		skp->SetPen(oldpen);
		skp->SetBrush(oldbrush);
		skp->Rectangle(x-1,y-1,boxx2+1,boxy2+1);

		#define bOFS 1
		DWORD oldtextcolor=skp->SetTextColor (cfg->hudshadowcolor);
		x=x+(width/2);
		y=y-1;
		sprintf_s(buf,"%.1f%%",ratio*100);
		skp->SetTextAlign(oapi::Sketchpad::CENTER);
		skp->Text(x-bOFS,y-bOFS,buf,(int)strlen(buf));// FIXME: shitty
		skp->Text(x-bOFS,y+bOFS,buf,(int)strlen(buf));
		skp->Text(x+bOFS,y-bOFS,buf,(int)strlen(buf));
		skp->Text(x+bOFS,y+bOFS,buf,(int)strlen(buf));
		skp->SetTextColor (cfg->hudselcolor);
		skp->Text(x,y,buf,(int)strlen(buf));
		skp->SetTextAlign(oapi::Sketchpad::LEFT);
		skp->SetTextColor (oldtextcolor);
		return;
}

bool ORION::clbkDrawHUD (int mode, const HUDPAINTSPEC *hps, oapi::Sketchpad *skp) {

	skp->SetFont (hudfont);

	double oldcolor=skp->SetTextColor (cfg->hudfontcolor);

	int side_offset = (int)floor((hps->W)/120.0);
	int top_offset = (int)floor((hps->H)/5.0);
	int draw_width = (int)floor((hps->W)/2.0);//3.3);
	int draw_height = (int)floor((hps->H)/3.3);
	int lowest=0;
	int _interval = 7;//8;//9;//7;//(int)(top_offset/20);
	int _from_top = 10;
//	int lowest=0;

	double vehmasst,vehmassf,rembombs,thlevel,thmax,thisp;
	THRUSTER_HANDLE th;
	VECTOR3 thref,thdir;
	VECTOR3 thmomentlin,thmomenttor;
	VECTOR3 vehthrustv,vehtorquev,vehweightv;
	VECTOR3 vehsscg;

	vehmasst=GetMass();
	vehmassf=GetFuelMass();
	//objmass=oapiGetMass(GetHandle());
	rembombs=vehmassf/500;

	//GetPMI(vehpmi);
	GetThrustVector(vehthrustv);
	GetTorqueVector(vehtorquev);
	GetWeightVector(vehweightv);
	GetSuperstructureCG(vehsscg);


	hudline("%s",hudtitle);
	char safestr[32];
	sprintf(safestr," <safety%s%s%s>",
		(cfg->nukesafety1?" 1":""),
		(cfg->nukesafety2?" 2":""),
		(cfg->nukesafety3?" 3":"")
	);
	hudline("%s%s%s",
		(cfg->nukearmed?"<Nukes ARMED>":"<Nukes offline>"),
		(cfg->nukesafety1 + cfg->nukesafety2 + cfg->nukesafety3 > 0 ? safestr : "" ),
		(cfg->rcs_cog_comp>0?" <RCS COG-CMP>":"")
	);
	_from_top = top_offset + _interval;
	if(cfg->hudmode) {
		char *menuKeys[HUDMENUCOUNT] = {"",
			"[ALT A]rm nukes, [ALT 1-3] safeties, [5-6] yield, [J] RCS COG comp, [L] airlock light, [CTRL L] clear log", 
			"[J] RCS COG comp", 
			"Crew: [1]/[2], Airlock: [3]/[4], [E]va, [M] add crew, [L] airlock light"};//,
			//"[L] on/off, [1-2] Mode, [6-7] Intensity, [num][7-4]/[8-5]/[9-6] R/G/B"};
		hudline("%s",menuKeys[cfg->hudmode]);
		skp->Line(side_offset + 10, _from_top, draw_width, _from_top);
	}
	if (cfg->hudmode==HUD_EVA) {
		int crewcount=Crew.GetCrewTotalNumber();
		hudline("UMMU %.4f, %d onboard.",Crew.GetUserUMmuVersion(),crewcount);
		//hudline("airlock: %s",(Crew.GetAirlockDoorState()?"open":"closed"));
		int mmuP=SelectedUmmuMember-1;
		if(mmuP<0) mmuP=crewcount-1;
		int mmuN=SelectedUmmuMember+1;
		if(mmuN>crewcount-1) mmuN=0;
		for (int i = 0; i < crewcount; i++) {
			if(SelectedUmmuMember==i) skp->SetTextColor (cfg->hudselcolor);
			hudline("%s %s - %s - %d",
				( SelectedUmmuMember==i ? "-->" :
					( mmuN==i ? "[2]" :
						( mmuP==i ? "[1]" : "   " )
					)
				),
				Crew.GetCrewNameBySlotNumber(i),
				Crew.GetCrewMiscIdBySlotNumber(i),
				Crew.GetCrewAgeBySlotNumber(i)
			);
			if(SelectedUmmuMember==i) skp->SetTextColor (cfg->hudfontcolor);
		}
		lowest=_from_top;
	} else if(cfg->hudmode==HUD_RCS) {
		hudline("COG%s: (L/R, U/D, F/B): %+.4f, %+.4f, %+.4f",(cfg->rcs_cog_comp?"(CMP)":""),vehsscg);
		hudline("Vehicle mass: %.4f, Superstructure mass: %.4f",vehmasst,ssmass);
//		hudline("ATT level: %f",GetThrusterGroupLevel(ENGINE_ATTITUDE));
		thgrouphud(THGROUP_ATT_PITCHUP,"pitch-U");
		thgrouphud(THGROUP_ATT_PITCHDOWN,"pitch-D");
		thgrouphud(THGROUP_ATT_YAWLEFT,"yaw-L");
		thgrouphud(THGROUP_ATT_YAWRIGHT,"yaw-R");
		thgrouphud(THGROUP_ATT_BANKLEFT,"bank-L");
		thgrouphud(THGROUP_ATT_BANKRIGHT,"bank-R");
		//hudline("rot comp: %s %f, rcs shift = %.4f,%.4f,%.4f",(rot_comp_mode==1?"ON":"OFF"),rot_comp_level,rcs_shift_vec);

		skp->Line(side_offset + 10, _from_top, draw_width, _from_top);
		skp->SetTextColor(cfg->hudmesgcolor);
		int lp=(syslogp-1)%SYSLOGSIZE;
		if (lp<0) lp=SYSLOGSIZE-1;
		hudline("lastmsg: %s",shiplog[lp].message);
		skp->SetTextColor(cfg->hudfontcolor);

		side_offset = (hps->W) - side_offset - draw_width+10;
		_from_top=top_offset+10+(1*_interval);
		if (rcs_shift_mode==1) {
			rcs_shift_mode=2;
			rcs_shift_vec=vehsscg;
		}
		thgrouphud(THGROUP_ATT_UP,"U");
		thgrouphud(THGROUP_ATT_DOWN,"D");
		thgrouphud(THGROUP_ATT_LEFT,"L");
		thgrouphud(THGROUP_ATT_RIGHT,"R");
		thgrouphud(THGROUP_ATT_FORWARD,"F");
		thgrouphud(THGROUP_ATT_BACK,"B");
	} else if (cfg->hudmode==HUD_MAIN) {
/*
#ifdef BOMBFUEL
		hudline("Mass - total: %0.2fkg, Bombs: %0.2fkg (%.0f bombs)",vehmasst,vehmassf,rembombs);
#else
		hudline("Mass - total: %0.2fkg, Bombs: %0.2fkg (# pulse: %d), RCS: %0.2fkg",
			vehmasst,vehmassf,boomcount,GetPropellantMass(ph_RCS));
#endif
*/
		double maxfuel, currfuel, fuelratio;

		int old_offset=side_offset;

		fuelratio=0.0;
		maxfuel=GetPropellantMaxMass(ph_main);
		currfuel=GetPropellantMass(ph_main);
		if(maxfuel>0.0) fuelratio=currfuel/maxfuel;
		drawbox(skp, old_offset+10, _from_top+4, (_interval*2)-1, 100, fuelratio );
		side_offset=side_offset+110;
		_from_top += 2; hudline("Bombs: %0.2f kg, Yield set to: %.0f%%",currfuel,cfg->nukeyield*100); _from_top -= 2;
		_from_top += 1*_interval;

		fuelratio=0.0;
		maxfuel=GetPropellantMaxMass(ph_RCS);
		currfuel=GetPropellantMass(ph_RCS);
		if(maxfuel>0.0) fuelratio=currfuel/maxfuel;
		drawbox(skp, old_offset+10, _from_top+4, (_interval*2)-1, 100, fuelratio );
		_from_top += 2;
		hudline("RCS: %0.2f kg",currfuel);
		_from_top -= 2;
		_from_top += 1*_interval;
		side_offset=old_offset;



		hudline("COG%s: (L/R, U/D, F/B): %+.6f, %+.6f, %+.6f",(cfg->rcs_cog_comp?"(CMP)":""),vehsscg);
		th=th_orion[0];
/*		GetThrusterDir(th, thdir);
		hudline("Ejection vector: %.5f, %.5f, %.5f",thdir);
*/

//		hudline("boom(%d)->%0.4f",boom->IsActive(),boom->GetIntensity());
//		hudline("PMI: %.4f, %.4f, %.4f",vehpmi.x,vehpmi.y,vehpmi.z);
		hudline("Thrust: %+.2f, %+.2f, %+.2f  Torque: %+.2f, %+.2f, %+.2f",
			vehthrustv,
			vehtorquev	
		);
		//hudline("Weight: %.2f, %.2f, %.2f",vehweightv);
#ifdef DEBUGHUD
		hudline(" %d+10,%d,... // W=%d, H=%d, CX=%d, CY=%d, Scale=%.3f, Markersize=%d",
			side_offset + 10, _from_top,
			hps->W,hps->H,hps->CX,hps->CY,hps->Scale,hps->Markersize
		);
		hudline("side_offset=%d, top_offset=%d, draw_width=%d, draw_height=%d, _interval=%d, _from_top=%d",
			side_offset, top_offset, draw_width, draw_height, _interval, _from_top);
#endif
		skp->Line(side_offset + 10, _from_top+1, draw_width, _from_top+1);
	
		skp->SetTextColor(cfg->hudmesgcolor);
		for(int i=syslogp;i<SYSLOGSIZE+syslogp;i++) {
			if(strlen(shiplog[i%SYSLOGSIZE].message)) {
				hudline("syslog %s",shiplog[i%SYSLOGSIZE].message);
			}
		}
		skp->SetTextColor(cfg->hudfontcolor);
			/*
		hudline("lastmsg: %s",hudlastmsg);
		if(dHudMessageDelay>0) {
			hudline("UMMU: %s",cUmmuHudDisplay);
			dHudMessageDelay-=oapiGetSimStep();
			if(dHudMessageDelay<0) dHudMessageDelay=0;
		}
		*/
	}

	side_offset = (hps->W) - side_offset - draw_width+10;
	_from_top=top_offset+10;
	if (cfg->hudmode==HUD_EVA) {
		side_offset = side_offset - 100;//(hps->W) - side_offset - draw_width+10;
		_from_top += 3*_interval;
		int dc=DockCount();

		int dockP=SelectedUmmuDock-1;
		if(dockP<0) dockP=dc-1;
		int dockN=SelectedUmmuDock+1;
		if(dockN>dc-1) dockN=0;

		for (int i = 0; i < dc; i++) {
			DOCKHANDLE Dock;
			OBJHANDLE Ship;
			char shipstr[64];
			if(DockingStatus(i)) {
				Dock=GetDockHandle(i);
				Ship=GetDockStatus(Dock);
				oapiGetObjectName(Ship,shipstr,64);
			}
			if(SelectedUmmuDock==i) skp->SetTextColor (cfg->hudselcolor);
			hudline("%s %d -> %s", 
				(SelectedUmmuDock==i ? "-->" : 
					(dockN==i ? "[4]" : 
						(dockP==i ? "[3]" : "   " )
					)
				),
				i+1,
				(DockingStatus(i) ? shipstr : "EVA" )
			);
			if(SelectedUmmuDock==i) skp->SetTextColor (cfg->hudfontcolor);
		}

		side_offset = (int)floor((hps->W)/120.0);
		if(_from_top<lowest) _from_top=lowest;
		skp->Line(side_offset + 10, _from_top, draw_width, _from_top);
		skp->SetTextColor(cfg->hudmesgcolor);
		int lp=(syslogp-1)%SYSLOGSIZE;
		if (lp<0) lp=SYSLOGSIZE-1;
		hudline("lastmsg: %s",shiplog[lp].message);
		skp->SetTextColor(cfg->hudfontcolor);
		/*
		if(dHudMessageDelay>0) {
			hudline("UMMU: %s",cUmmuHudDisplay);
			dHudMessageDelay-=oapiGetSimStep();
			if(dHudMessageDelay<0) dHudMessageDelay=0;
		}*/
	} else if(cfg->hudmode==HUD_RCS) {
	} else if(cfg->hudmode==HUD_MAIN) {
	}
	//dprint("clbkDrawHUD: done");
	return true;
}
